/* 
 * nfsinit.
 * NOTE: This file is duplicated in mount-2.71 and mount-2.10m/mount
 */
#include <stdio.h>
#include <unistd.h>
#include <string.h>

#define NFSINIT_DEBUG

int 
main(int argc, char **argv, char **envp)
{
  int mount_main(int,char**);
  int rval;
  int nfsinit_argc = 0;
  char *nfsinit_argv[10];
  int i;
  char nfshandle[128];
  char *nfsinitstr = 0, *srcrootstr = 0;

  /* Assmble mount arglist. */
  /* We think we are the mount command. */
#ifdef NFSINIT_DEBUG
  printf("nfsinit startup\n");
  fflush(stdout);
#endif
  nfsinit_argv[nfsinit_argc++] = "mount";

  nfsinit_argv[nfsinit_argc++] = "-n";

  /* NFS handle. */
  nfsinit_argv[nfsinit_argc] = 0;
  for(i=0;;i++) {
    if (!envp[i]) break;
    if (!strncmp(envp[i], "nfsinit=", 8)) {
      nfsinitstr = envp[i]+8;
    } else if (!strncmp(envp[i], "srcroot=", 8)) {
      srcrootstr = envp[i]+8;
    }
  }
  if (srcrootstr) {
    char *cp = index(srcrootstr, ':');
    
    if (cp)
      nfsinit_argv[nfsinit_argc++] = srcrootstr;
    else {
      strcpy(nfshandle, nfsinitstr);
      cp = index(nfshandle, ':');
      if (!cp) {
        printf("No ip address in nfsinit\n");
        return 1;
      }
      cp++;
      strcpy(cp, srcrootstr);
      nfsinit_argv[nfsinit_argc++] = nfshandle;
    }
  } else {
    strcpy(nfshandle,nfsinitstr);
    strcat(nfshandle, "/../../srcroot");
    nfsinit_argv[nfsinit_argc++] = nfshandle;
  }


  /* Local mount point is always /srcroot */
  nfsinit_argv[nfsinit_argc++] = "/srcroot";

  /* Terminate the list. */
  nfsinit_argv[nfsinit_argc] = 0;

#ifdef NFSINIT_DEBUG
  printf("NFS Args: \n");
  for(i=0;;i++) {
    if (!nfsinit_argv[i]) break;
    printf("a[%d]=%s\n", i, nfsinit_argv[i]);
  }
  printf("Args: \n");
  for(i=0;;i++) {
    if (!argv[i]) break;
    printf("a[%d]=%s\n", i, argv[i]);
  }
  printf("Env: \n");
  for(i=0;;i++) {
    if (!envp[i]) break;
    printf("a[%d]=%s\n", i, envp[i]);
  }
  fflush(stdout);
#endif
  if (rval = mount_main(nfsinit_argc,nfsinit_argv)) {
    perror("nfsinit mount error: ");
    return rval;
  }
#ifdef NFSINIT_DEBUG
  printf("nfsinit, exec init\n");
  fflush(stdout);
#endif
  i =  execve("/sbin/init", argv, envp);
  printf("execve returns %d\n", i);
  perror("nfsinit execve error: ");
  return(1);
}
